classification
Title: singledispatch register should typecheck its argument
Type: behavior Stage: resolved
Components: Versions: Python 3.8, Python 3.7, Python 3.6
process
Status: closed Resolution: duplicate
Dependencies: Superseder: singledispatch support for type annotations
View: 32227
Assigned To: Nosy List: amogorkon, cheryl.sabella, eryksun, ethan.furman, lukasz.langa, ncoghlan, rhettinger, xiang.zhang
Priority: normal Keywords: patch

Created on 2016-09-06 23:18 by amogorkon, last changed 2018-03-15 10:33 by xiang.zhang. This issue is now closed.

Files
File name Uploaded Description Edit
issue27984.patch xiang.zhang, 2016-09-07 09:39 review
Pull Requests
URL Status Linked Edit
PR 6114 closed xiang.zhang, 2018-03-14 13:02
PR 6115 closed xiang.zhang, 2018-03-14 13:11
Messages (12)
msg274661 - (view) Author: Anselm Kiefner (amogorkon) Date: 2016-09-06 23:18
from functools import singledispatch
from enum import Enum

IS = Enum("IS", "a, b")

@singledispatch
def foo(x):
    print(foo.dispatch(x))
    print("foo")

@foo.register(IS.a)
def bar(x):
    print(foo.dispatch(x))
    print("bar")
    
@foo.register(int)
def baz(x):
    print("baz")
    
>>> foo(IS.a)
<function bar at 0x7fa92c319d90>
foo


I think the result is self-explaining. The foo.dispatch() correctly says function bar should be handling the call when IS.a is passed, but foo is handling the call anyway. If an int is passed, baz works as expected.
msg274666 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2016-09-06 23:34
> IS = Enum("IS", "a, b")

functools is meant to work with types, but the enum member "IS.a" is not a type -- however, the enum "IS" is a type.

Use "foo.register(IS)" instead.
msg274669 - (view) Author: Eryk Sun (eryksun) * (Python triager) Date: 2016-09-06 23:43
The register() method should raise a TypeError if it's called with an object that's not a type.

Consider the following:

    from functools import singledispatch

    class C:
        pass

    obj = C()

    @singledispatch
    def foo(x):
        print(foo.dispatch(x))
        print("foo")

    @foo.register(obj)
    def bar(x):
        print(foo.dispatch(x))
        print("bar")


    >>> foo(obj)
    <function bar at 0x7f16f2adc9d8>
    foo
msg274704 - (view) Author: Nick Coghlan (ncoghlan) * (Python committer) Date: 2016-09-07 02:22
Catching the erroneous registration rather than silently ignoring it sounds like the right thing to do here to me as well.

I'm actually surprised that code isn't already throwing an exception later on, as "isinstance" itself does fail with non-types:

>>> from enum import Enum
>>> 
>>> IS = Enum("IS", "a, b")
>>> isinstance(IS.a, IS)
True
>>> isinstance(IS.a, IS.a)
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
TypeError: isinstance() arg 2 must be a type or tuple of types
msg274784 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2016-09-07 09:39
It's also better to add the typecheck to dispatch. Otherwise sometimes it can generate not obvious exception message.

>>> from enum import IntEnum
>>> from functools import singledispatch
>>> IS = IntEnum("IS", "a, b")
>>> @singledispatch
... def foo(x):
...     pass
... 
>>> foo.dispatch(IS.a)
Traceback (most recent call last):
  File "<stdin>", line 1, in <module>
  File "/home/angwer/cpython/Lib/functools.py", line 718, in dispatch
    impl = dispatch_cache[cls]
  File "/home/angwer/cpython/Lib/weakref.py", line 365, in __getitem__
    return self.data[ref(key)]
TypeError: cannot create weak reference to 'IS' object
>>>
msg313770 - (view) Author: Cheryl Sabella (cheryl.sabella) * (Python triager) Date: 2018-03-13 19:43
@xiang.zhang, would you be able to make a PR for your patch?  Thanks!
msg313800 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2018-03-14 03:34
Thanks for the reminding, I already forget this. I'll do it night.
msg313818 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2018-03-14 12:27
Revising the patch, register() is fixed by feature in #32227. So I will only fix dispatch() in 3.7 and 3.8, the whole patch to 3.6.
msg313842 - (view) Author: Łukasz Langa (lukasz.langa) * (Python committer) Date: 2018-03-14 22:23
I'm sorry that you wasted your time on those pull requests, Xiang but:
- we cannot accept any new features for 3.6 and 3.7 anymore;
- the problem described in this issue is fixed, as you noticed yourself, by #32227.

The wrapper returned by the `@register` decorator is calling `dispatch()` with the first argument's `__class__`. It can only ever be invalid if somebody deliberately wrote something invalid to the object's `__class__`. It's extremely unlikely.

We should not slow down *calling* of all generic functions on the basis that somebody might pass a non-type straigh to `dispatch()`.

Cheryl, thanks for your help triaging the bug tracker! It might be a good idea to confirm with people on old issues whether moving the patch to a pull request is indeed the missing part of it getting merged. In this case it wasn't, I hope Xiang won't feel bad about me rejecting his pull requests after you pinged him for them.
msg313845 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2018-03-14 23:37
It's all right.
msg313865 - (view) Author: Cheryl Sabella (cheryl.sabella) * (Python triager) Date: 2018-03-15 10:01
Łukasz,

Sorry about that.  Since Xiang is a core developer, I thought he would be in the position to make the decision about moving forward with the patch.  I apologize for causing unnecessary work.
msg313869 - (view) Author: Xiang Zhang (xiang.zhang) * (Python committer) Date: 2018-03-15 10:33
Cheryl, It's a good remind for me. I totally forget about this issue.

> Since Xiang is a core developer, I thought he would be in the position to make the decision about moving forward with the patch.

Yes, I made the decision. But seems not a wise one, sorry. :-( But fortunately Łukasz noticed it. :-)

I am happy to see finally this issue is solved, instead of hanging with no reply. :-) Thanks for Łukasz and Cheryl.

I am sorry for the PRs making noise here. Again, it's quite all right for me to close them. :-)
History
Date User Action Args
2018-03-15 10:33:30xiang.zhangsetmessages: + msg313869
2018-03-15 10:01:38cheryl.sabellasetmessages: + msg313865
2018-03-14 23:37:21xiang.zhangsetmessages: + msg313845
2018-03-14 22:23:48lukasz.langasetstatus: open -> closed
superseder: singledispatch support for type annotations
messages: + msg313842

resolution: duplicate
stage: patch review -> resolved
2018-03-14 13:11:00xiang.zhangsetpull_requests: + pull_request5878
2018-03-14 13:02:59xiang.zhangsetpull_requests: + pull_request5877
2018-03-14 12:27:53xiang.zhangsetmessages: + msg313818
versions: + Python 3.6
2018-03-14 03:34:01xiang.zhangsetmessages: + msg313800
2018-03-13 19:43:03cheryl.sabellasetversions: + Python 3.7, Python 3.8, - Python 3.5, Python 3.6
nosy: + cheryl.sabella

messages: + msg313770

stage: patch review
2016-09-07 09:39:08xiang.zhangsetfiles: + issue27984.patch

nosy: + xiang.zhang
messages: + msg274784

keywords: + patch
2016-09-07 02:22:04ncoghlansetmessages: + msg274704
2016-09-06 23:46:50berker.peksagsetnosy: + lukasz.langa
2016-09-06 23:43:10eryksunsetnosy: + eryksun
title: singledispatch is wonky with enums -> singledispatch register should typecheck its argument
messages: + msg274669

versions: + Python 3.6
2016-09-06 23:34:21ethan.furmansetnosy: + rhettinger, ncoghlan
messages: + msg274666
2016-09-06 23:23:48ethan.furmansetnosy: + ethan.furman
2016-09-06 23:18:51amogorkoncreate